#include "keyboard.h"

float tran[3][4] ;

void init(void)
{
	glClearColor(1.0, 1.0, 1.0, 0.0) ;
	glShadeModel(GL_FLAT) ;

	tran[SCALE][0] = 1.0 ;
	tran[SCALE][1] = 1.0 ;
	tran[SCALE][2] = 1.0 ;
	tran[ROTATE][0] = 1.0 ;
	tran[ROTATE][1] = 0.0 ;
	tran[ROTATE][2] = 0.0 ;
}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT) ;
	glShadeModel(GL_FLAT) ;

	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	glViewport(0,100,100,100) ;
	glOrtho(-2.0,2.0,-2.0,2.0,2.0,-2.0) ;
	glMatrixMode(GL_MODELVIEW) ;
	Draw_Cube_Transl_Rot() ;

	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	glViewport(0,0,100,100) ;
	gluPerspective(60.0, 1.0,1.0,20.0) ;
	glTranslatef(0.0,0.0,-4.0) ;
	glMatrixMode(GL_MODELVIEW) ;
	Draw_Cube_Transl_Rot() ;

	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	glViewport(100,100,100,100) ;
	glOrtho(-2.0,2.0,-2.0,2.0,2.0,-2.0) ;
	glMatrixMode(GL_MODELVIEW) ;
	Draw_Cube_Rot_Transl() ;

	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	glViewport(100,0,100,100) ;
	gluPerspective(60.0, 1.0,1.0,20.0) ;
	glTranslatef(0.0,0.0,-4.0) ;
	glMatrixMode(GL_MODELVIEW) ;
	Draw_Cube_Rot_Transl() ;
	
	glutSwapBuffers() ;
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv) ;
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB) ;
	glutInitWindowSize(200, 200) ;
	glutInitWindowPosition(100, 100) ;
	glutCreateWindow("Second Chapter - Drawing and applying transformations on a cube") ;

	init() ;

	glutDisplayFunc(display) ;
	glutKeyboardFunc(keyboard) ;

	glutMainLoop() ;

	return 0 ;
}