#include "transformations.h"

void Rotate_Cube3D(void)
{
	tran[ROTATE][0] = 1.0 ;
   tran[ROTATE][1] = 1.0 ;
   tran[ROTATE][2] = 1.0 ;
   tran[ROTATE][3] += 1 ;
}

void Rotate_Cube(void)
{
   static int flag = 0 ;

   tran[ROTATE][3] += 1 ;

   switch (flag)
   {
      case 0 :
         if (tran[ROTATE][3] > 85.0)
         {
            tran[ROTATE][3] = 0.0 ;
            tran[ROTATE][0] = 0.0 ;
            tran[ROTATE][1] = 1.0 ;
            flag = 1 ;
         }
         break ;
      case 1 :
         if (tran[ROTATE][3] > 85.0)
         {
         	tran[ROTATE][3] = 0.0 ;
            tran[ROTATE][1] = 0.0 ;
            tran[ROTATE][2] = 1.0 ;
            flag = 2 ;
         }
         break ;
      case 2 :
         if (tran[ROTATE][3] > 85.0)
         {
            tran[ROTATE][0] = 1.0 ;
            tran[ROTATE][1] = 1.0 ;
            flag = 3 ;
         }
         break ;
		default :
         break ;
   }
}

void Move_Cube(void)
{
   static int flag = 0 ;

   switch (flag)
   {
      case 0 :
         tran[TRANS][0] += 0.01  ;
         if (tran[TRANS][0] >= 0.5)
              flag = 1 ;
         break ;
      case 1 :
         tran[TRANS][1] += 0.01  ;
         if (tran[TRANS][1] >= 0.5)
              flag = 2 ;
         break ;
      case 2 :
         tran[TRANS][0] -= 0.01  ;
         if (tran[TRANS][0] <= -0.5)
              flag = 3 ;
         break ;
      case 3 :
         tran[TRANS][1] -= 0.01  ;
         if (tran[TRANS][1] <= -0.0)
              flag = 4 ;
         break ;
      case 4 :
         tran[TRANS][0] += 0.01  ;
         if (tran[TRANS][0] >= 0.0)
              flag = 0 ;
         break ;
 		default :
         break ;
   }
}

void Scale_Cube(void)
{
	static int flag = 0 ;

   switch (flag)
   {
      case 0 :
         tran[SCALE][0] += 0.01 ;
         if (tran[SCALE][0] >= 2.0)
            flag = 1 ;
         break ;
      case 1 :
         tran[SCALE][0] -= 0.01 ;
         if (tran[SCALE][0] <= -2.0)
            flag = 0 ;
         break ;

      default :
         break ;
   }
}

void Small_Anim(void)
{
   Rotate_Cube3D() ;
   Move_Cube() ;
   glutPostRedisplay() ;
}

void Draw_Cube_Transl_Rot(void)
{
   glPushMatrix() ;
   glTranslatef(tran[TRANS][0],tran[TRANS][1],tran[TRANS][2]) ;
   glRotatef(tran[ROTATE][3],tran[ROTATE][0],tran[ROTATE][1],tran[ROTATE][2]) ;
   glScalef(tran[SCALE][0],tran[SCALE][1],tran[SCALE][2]) ;
   Draw_Black_Cube() ;
   glPopMatrix() ;
}

void Draw_Cube_Rot_Transl(void)
{
   glPushMatrix() ;
   glRotatef(tran[ROTATE][3],tran[ROTATE][0],tran[ROTATE][1],tran[ROTATE][2]) ;
   glTranslatef(tran[TRANS][0],tran[TRANS][1],tran[TRANS][2]) ;
   glScalef(tran[SCALE][0],tran[SCALE][1],tran[SCALE][2]) ;
   Draw_Black_Cube() ;
   glPopMatrix() ;
}
